/***************************************************************************************/
/* Unterprogramme zur Erzeugung des Flackerlichts (fuer die Kerzen) mit Hilfe einer    */
/* Tabelle                                                                             */
/*                                                                                     */
/* Compiler: CC5X                                                                      */
/*                                                                                     */
/* Entwickler: Buchgeher Stefan                                                        */
/* Entwicklungsbeginn der Software: 27. September 2008                                 */
/* Funktionsfaehig seit: 27. September 2008                                            */
/* Letzte Bearbeitung: 21. Juni 2009                                                   */
/***************************************************************************************/

/****************** Include-Dateien ****************************************************/
#include "PROJEKT.H"
 

/****************** Globale Register ***************************************************/
#pragma rambank 1

char    PWM_Zaehler_Kerzen;     	// Hilfszaehler zur Erzeugung der PWM
char    Gleichheitszaehler_Kerzen;    	// mehrere gleiche PWMs nacheinander

char    TabZaehlerTagB;         	// Tabellen-Zeiger fuer Tag B (Kerze)
char    TabZaehlerTagC;         	// Tabellen-Zeiger fuer Tag C (Kerze)
char    TabZaehlerTagD;         	// Tabellen-Zeiger fuer Tag D (Kerze)
char    TabZaehlerTagE;         	// Tabellen-Zeiger fuer Tag E (Kerze)
char    TabZaehlerTagF;         	// Tabellen-Zeiger fuer Tag F (Kerze)
char    TabZaehlerTagG;         	// Tabellen-Zeiger fuer Tag G (Kerze)
char    TabZaehlerTagH;         	// Tabellen-Zeiger fuer Tag H (Kerze)
char    TabZaehlerTagI;         	// Tabellen-Zeiger fuer Tag I (Kerze)
char    TabZaehlerTagJ;         	// Tabellen-Zeiger fuer Tag J (Kerze)
char    TabZaehlerTagK;         	// Tabellen-Zeiger fuer Tag K (Kerze)
char    TabZaehlerTagL;         	// Tabellen-Zeiger fuer Tag L (Kerze)
char    TabZaehlerTagM;         	// Tabellen-Zeiger fuer Tag M (Kerze)
char    TabZaehlerTagN;         	// Tabellen-Zeiger fuer Tag N (Kerze)
char    TabZaehlerTagO;         	// Tabellen-Zeiger fuer Tag O (Kerze)
char    TabZaehlerTagP;         	// Tabellen-Zeiger fuer Tag P (Kerze)
char    TabZaehlerTagQ;         	// Tabellen-Zeiger fuer Tag Q (Kerze)
char    TabZaehlerTagR;         	// Tabellen-Zeiger fuer Tag R (Kerze)
char    TabZaehlerTagS;         	// Tabellen-Zeiger fuer Tag S (Kerze)
char    TabZaehlerTagT;         	// Tabellen-Zeiger fuer Tag T (Kerze)
char    TabZaehlerTagU;         	// Tabellen-Zeiger fuer Tag U (Kerze)
char    TabZaehlerTagV;         	// Tabellen-Zeiger fuer Tag V (Kerze)
char    TabZaehlerTagW;         	// Tabellen-Zeiger fuer Tag W (Kerze)
char    TabZaehlerTagX;         	// Tabellen-Zeiger fuer Tag X (Kerze)
char    TabZaehlerTagY;         	// Tabellen-Zeiger fuer Tag Y (Kerze)
 
#pragma rambank 2
char    PWM_LED_TagB;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagC;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagD;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagE;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagF;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagG;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagH;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagI;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagJ;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagK;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagL;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagM;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagN;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagO;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagP;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagQ;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagR;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagS;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagT;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagU;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagV;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagW;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagX;           	// beinhaltet den Tabellenwert (PWM; Kerze)
char    PWM_LED_TagY;           	// beinhaltet den Tabellenwert (PWM; Kerze)

 
/****************** Unterprogramme und Funktionen **************************************/

/***************************************************************************************/
/* Init_Flackerlicht_Kerzen:                                                           */
/*                                                                                     */
/* Aufgaben:                                                                           */
/*   + Zaehlregister fuer die Flackerlichter (Tabellen) initialisieren                 */
/*   + Register fuer die Puls-Weiten-Modulation (PWM) initialisieren                   */
/*                                                                                     */
/* Uebergabeparameter:                                                                 */
/*   keiner                                                                            */
/*                                                                                     */
/* Rueckgabeparameter:                                                                 */
/*   keiner                                                                            */
/***************************************************************************************/
void Init_Flackerlicht_Kerzen(void)
{
    // Zaehlregister fuer die Flackerlichter (Tabellen) initialisieren
    TabZaehlerTagB = KONST_TABSTART_TAGB;
    TabZaehlerTagC = KONST_TABSTART_TAGC;
    TabZaehlerTagD = KONST_TABSTART_TAGD;
    TabZaehlerTagE = KONST_TABSTART_TAGE;
    TabZaehlerTagF = KONST_TABSTART_TAGF;
    TabZaehlerTagG = KONST_TABSTART_TAGG;
    TabZaehlerTagH = KONST_TABSTART_TAGH;
    TabZaehlerTagI = KONST_TABSTART_TAGI;
    TabZaehlerTagJ = KONST_TABSTART_TAGJ;
    TabZaehlerTagK = KONST_TABSTART_TAGK;
    TabZaehlerTagL = KONST_TABSTART_TAGL;
    TabZaehlerTagM = KONST_TABSTART_TAGM;
    TabZaehlerTagN = KONST_TABSTART_TAGN;
    TabZaehlerTagO = KONST_TABSTART_TAGO;
    TabZaehlerTagP = KONST_TABSTART_TAGP;
    TabZaehlerTagQ = KONST_TABSTART_TAGQ;
    TabZaehlerTagR = KONST_TABSTART_TAGR;
    TabZaehlerTagS = KONST_TABSTART_TAGS;
    TabZaehlerTagT = KONST_TABSTART_TAGT;
    TabZaehlerTagU = KONST_TABSTART_TAGU;
    TabZaehlerTagV = KONST_TABSTART_TAGV;
    TabZaehlerTagW = KONST_TABSTART_TAGW;
    TabZaehlerTagX = KONST_TABSTART_TAGX;
    TabZaehlerTagY = KONST_TABSTART_TAGY;
    
    
    // Register fuer die Puls-Weiten-Modulation (PWM) initialisieren
    PWM_Zaehler_Kerzen = 0;
    Gleichheitszaehler_Kerzen = KONST_GLEICHHEIT;
}


/***************************************************************************************/
/* Flackerlicht_Kerzen:                                                                */
/*                                                                                     */
/* Aufruf:                                                                             */
/*   alle 409 us (vom Hauptprogramm)                                                   */
/*                                                                                     */
/* Aufgabe:                                                                            */
/*   PWM fuer die Flackerlichter (Kerzen) erzeugen, und die Leuchtdioden (Bits         */
/*   TAGx_FLAMME und TAGxWACHS) setzen oder ruecksetzen.                               */          
/*                                                                                     */
/* Vorgehensweise:                                                                     */
/*   + PWM_Zaehler_Kerzen = 0: Je nachdem ob die Kerze "aktiv" ist                     */
/*     (TagesZaehler >= KONST_TAGx) diese Kerze (Flamme und Wachs) setzen oder rueck-  */
/*     setzen, und den naechsten Wert aus der Tabelle TabFlackerlicht lesen.           */
/*   + PWM_Zaehler_Kerzen == PWM_LED_Tagx: Die Leuchtdiode (Flamme der Kerze, Bit      */
/*     TAGx_FLAMME) ruecksetzen                                                        */
/*   + TabZaehlerTagx gibt an, welcher PWM-Wert aus der Tabelle (TabFlackerlicht)      */
/*     ausgegeben werden soll.                                                         */
/*                                                                                     */
/* Uebergabeparameter:                                                                 */
/*   keiner                                                                            */
/*                                                                                     */
/* Rueckgabeparameter:                                                                 */
/*   keiner                                                                            */
/*                                                                                     */
/* Anmerkung:                                                                          */
/*  + Zykluswiederholzeit des "Flackerns" bei einer Tabelle mit 256 Werten:            */
/*                                                                                     */
/*           4                                                                         */
/*    T = -------- * 256 * 8 * 32 * 5 * 256 = 16777216 us = ca. 17 Sekunden            */
/*        20 [MHz]                                                                     */
/*         |         |    |    |   |    |                                              */
/*         |         |    |    |   |    +-- Anz. der Tabellenwerte (hier 256)          */
/*         |         |    |    |   +------- Anz. der gleichen PWM (hier 5)             */
/*         |         |    |    +----------- max. PWM-Zyklen -> 61 Hz                   */
/*         |         |    +---------------- Vorteiler fuer Timer 0 (hier 8)            */
/*         |         +--------------------- Timer-0-Ueberlauf                          */
/*         +------------------------------- Takt                                       */
/***************************************************************************************/
void Flackerlicht_Kerzen(void)
{
    if (PWM_Zaehler_Kerzen == 0)
    {
        if (TagesZaehler >= KONST_TAGB)
        {
            TAGB_FLAMME = 1;
            TAGB_WACHS = 1;
        }
        else
        {
            TAGB_FLAMME = 0;
            TAGB_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGC)
        {
            TAGC_FLAMME = 1;
            TAGC_WACHS = 1;
        }
        else
        {
            TAGC_FLAMME = 0;
            TAGC_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGD)
        {
            TAGD_FLAMME = 1;
            TAGD_WACHS = 1;
        }
        else
        {
            TAGD_FLAMME = 0;
            TAGD_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGE)
        {
            TAGE_FLAMME = 1;
            TAGE_WACHS = 1;
        }
        else
        {
            TAGE_FLAMME = 0;
            TAGE_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGF)
        {
            TAGF_FLAMME = 1;
            TAGF_WACHS = 1;
        }
        else
        {
            TAGF_FLAMME = 0;
            TAGF_WACHS = 0;
        }
        
        if (TagesZaehler >= KONST_TAGG)
        {
            TAGG_FLAMME = 1;
            TAGG_WACHS = 1;
        }
        else
        {
            TAGG_FLAMME = 0;
            TAGG_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGH)
        {
            TAGH_FLAMME = 1;
            TAGH_WACHS = 1;
        }
        else
        {
            TAGH_FLAMME = 0;
            TAGH_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGI)
        {
            TAGI_FLAMME = 1;
            TAGI_WACHS = 1;
        }
        else
        {
            TAGI_FLAMME = 0;
            TAGI_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGJ)
        {
            TAGJ_FLAMME = 1;
            TAGJ_WACHS = 1;
        }
        else
        {
            TAGJ_FLAMME = 0;
            TAGJ_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGK)
        {
            TAGK_FLAMME = 1;
            TAGK_WACHS = 1;
        }
        else
        {
            TAGK_FLAMME = 0;
            TAGK_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGL)
        {
            TAGL_FLAMME = 1;
            TAGL_WACHS = 1;
        }
        else
        {
            TAGL_FLAMME = 0;
            TAGL_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGM)
        {
            TAGM_FLAMME = 1;
            TAGM_WACHS = 1;
        }
        else
        {
            TAGM_FLAMME = 0;
            TAGM_WACHS = 0;
        }


        if (TagesZaehler >= KONST_TAGN)
        {
            TAGN_FLAMME = 1;
            TAGN_WACHS = 1;
        }
        else
        {
            TAGN_FLAMME = 0;
            TAGN_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGO)
        {
            TAGO_FLAMME = 1;
            TAGO_WACHS = 1;
        }
        else
        {
            TAGO_FLAMME = 0;
            TAGO_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGP)
        {
            TAGP_FLAMME = 1;
            TAGP_WACHS = 1;
        }
        else
        {
            TAGP_FLAMME = 0;
            TAGP_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGQ)
        {
            TAGQ_FLAMME = 1;
            TAGQ_WACHS = 1;
        }
        else
        {
            TAGQ_FLAMME = 0;
            TAGQ_WACHS = 0;
        }
        
        if (TagesZaehler >= KONST_TAGR)
        {
            TAGR_FLAMME = 1;
            TAGR_WACHS = 1;
        }
        else
        {
            TAGR_FLAMME = 0;
            TAGR_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGS)
        {
            TAGS_FLAMME = 1;
            TAGS_WACHS = 1;
        }
        else
        {
            TAGS_FLAMME = 0;
            TAGS_WACHS = 0;
        }
        
        if (TagesZaehler >= KONST_TAGT)
        {
            TAGT_FLAMME = 1;
            TAGT_WACHS = 1;
        }
        else
        {
            TAGT_FLAMME = 0;
            TAGT_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGU)
        {
            TAGU_FLAMME = 1;
            TAGU_WACHS = 1;
        }
        else
        {
            TAGU_FLAMME = 0;
            TAGU_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGV)
        {
            TAGV_FLAMME = 1;
            TAGV_WACHS = 1;
        }
        else
        {
            TAGV_FLAMME = 0;
            TAGV_WACHS = 0;
        }

        if (TagesZaehler >= KONST_TAGW)
        {
            TAGW_FLAMME = 1;
            TAGW_WACHS = 1;
        }
        else
        {
            TAGW_FLAMME = 0;
            TAGW_WACHS = 0;
        }       

        if (TagesZaehler >= KONST_TAGX)
        {
            TAGX_FLAMME = 1;
            TAGX_WACHS = 1;
        }
        else
        {
            TAGX_FLAMME = 0;
            TAGX_WACHS = 0;
        }       

        if (TagesZaehler >= KONST_TAGY)
        {
            TAGY_FLAMME = 1;
            TAGY_WACHS = 1;
        }
        else
        {
            TAGY_FLAMME = 0;
            TAGY_WACHS = 0;
        }       
 
        Gleichheitszaehler_Kerzen--;
        if (Gleichheitszaehler_Kerzen == 0)
        {
            Gleichheitszaehler_Kerzen = KONST_GLEICHHEIT;

            TabZaehlerTagB++;
            PWM_LED_TagB = TabFlackerlicht[TabZaehlerTagB];

            TabZaehlerTagC++;
            PWM_LED_TagC = TabFlackerlicht[TabZaehlerTagC];

            TabZaehlerTagD++;
            PWM_LED_TagD = TabFlackerlicht[TabZaehlerTagD];

            TabZaehlerTagE++;
            PWM_LED_TagE = TabFlackerlicht[TabZaehlerTagE];

            TabZaehlerTagF++;
            PWM_LED_TagF = TabFlackerlicht[TabZaehlerTagF];

            TabZaehlerTagG++;
            PWM_LED_TagG = TabFlackerlicht[TabZaehlerTagG];

            TabZaehlerTagH++;
            PWM_LED_TagH = TabFlackerlicht[TabZaehlerTagH];

            TabZaehlerTagI++;
            PWM_LED_TagI = TabFlackerlicht[TabZaehlerTagI];

            TabZaehlerTagJ++;
            PWM_LED_TagJ = TabFlackerlicht[TabZaehlerTagJ];

            TabZaehlerTagK++;
            PWM_LED_TagK = TabFlackerlicht[TabZaehlerTagK];

            TabZaehlerTagL++;
            PWM_LED_TagL = TabFlackerlicht[TabZaehlerTagL];

            TabZaehlerTagM++;
            PWM_LED_TagM = TabFlackerlicht[TabZaehlerTagM];

            TabZaehlerTagN++;
            PWM_LED_TagN = TabFlackerlicht[TabZaehlerTagN];

            TabZaehlerTagO++;
            PWM_LED_TagO = TabFlackerlicht[TabZaehlerTagO];

            TabZaehlerTagP++;
            PWM_LED_TagP = TabFlackerlicht[TabZaehlerTagP];

            TabZaehlerTagQ++;
            PWM_LED_TagQ = TabFlackerlicht[TabZaehlerTagQ];

            TabZaehlerTagR++;
            PWM_LED_TagR = TabFlackerlicht[TabZaehlerTagR];

            TabZaehlerTagS++;
            PWM_LED_TagS = TabFlackerlicht[TabZaehlerTagS];

            TabZaehlerTagT++;
            PWM_LED_TagT = TabFlackerlicht[TabZaehlerTagT];

            TabZaehlerTagU++;
            PWM_LED_TagU = TabFlackerlicht[TabZaehlerTagU];

            TabZaehlerTagV++;
            PWM_LED_TagV = TabFlackerlicht[TabZaehlerTagV];

            TabZaehlerTagW++;
            PWM_LED_TagW = TabFlackerlicht[TabZaehlerTagW];

            TabZaehlerTagX++;
            PWM_LED_TagX = TabFlackerlicht[TabZaehlerTagX];

            TabZaehlerTagY++;
            PWM_LED_TagY = TabFlackerlicht[TabZaehlerTagY];
         }
    }
    else
    {
        if (PWM_Zaehler_Kerzen == PWM_LED_TagB) TAGB_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagC) TAGC_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagD) TAGD_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagE) TAGE_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagF) TAGF_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagG) TAGG_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagH) TAGH_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagI) TAGI_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagJ) TAGJ_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagK) TAGK_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagL) TAGL_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagM) TAGM_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagN) TAGN_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagO) TAGO_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagP) TAGP_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagQ) TAGQ_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagR) TAGR_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagS) TAGS_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagT) TAGT_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagU) TAGU_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagV) TAGV_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagW) TAGW_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagX) TAGX_FLAMME = 0;
        if (PWM_Zaehler_Kerzen == PWM_LED_TagY) TAGY_FLAMME = 0;
    }

    PWM_Zaehler_Kerzen++;
    if (PWM_Zaehler_Kerzen == KONST_PWM_OBERGRENZE) 
    {
        PWM_Zaehler_Kerzen = 0;
    }
}



 