/***************************************************************************************/
/* Unterprogramme zur Erzeugung des Flackerlichts (fuer den Stern) mit Hilfe einer     */
/* Tabelle                                                                             */
/*                                                                                     */
/* Compiler: CC5X                                                                      */
/*                                                                                     */
/* Entwickler: Buchgeher Stefan                                                        */
/* Entwicklungsbeginn der Software: 27. September 2008                                 */
/* Funktionsfaehig seit: 27. September 2008                                            */
/* Letzte Bearbeitung: 21. Juni 2009                                                   */
/***************************************************************************************/

/****************** Include-Dateien ****************************************************/
#include "PROJEKT.H"
 

/****************** Globale Register ***************************************************/
#pragma rambank 3

char    PWM_Zaehler_Stern;            	// Hilfszaehler zur Erzeugung der PWM
char    Gleichheitszaehler_Stern;     	// mehrere gleiche PWMs nacheinander

char    TabZaehlerTagZ1;        	// Tabellen-Zeiger fuer Tag Z Stern)
char    TabZaehlerTagZ2;        	// Tabellen-Zeiger fuer Tag Z Stern)
char    TabZaehlerTagZ3;        	// Tabellen-Zeiger fuer Tag Z Stern)
char    TabZaehlerTagZ4;        	// Tabellen-Zeiger fuer Tag Z Stern)
char    TabZaehlerTagZ5;        	// Tabellen-Zeiger fuer Tag Z Stern)
char    TabZaehlerTagZ6;        	// Tabellen-Zeiger fuer Tag Z Stern)
char    TabZaehlerTagZ7;        	// Tabellen-Zeiger fuer Tag Z Stern)
char    TabZaehlerTagZ8;        	// Tabellen-Zeiger fuer Tag Z Stern)
char    TabZaehlerTagZ9;        	// Tabellen-Zeiger fuer Tag Z Stern)
char    TabZaehlerTagZ10;       	// Tabellen-Zeiger fuer Tag Z Stern)
char    TabZaehlerTagZ11;       	// Tabellen-Zeiger fuer Tag Z Stern)
char    TabZaehlerTagZ12;       	// Tabellen-Zeiger fuer Tag Z Stern)

//#pragma rambank 2
char    PWM_LED_TagZ1;          	// beinhaltet den Tabellenwert (PWM; Stern)
char    PWM_LED_TagZ2;          	// beinhaltet den Tabellenwert (PWM; Stern)
char    PWM_LED_TagZ3;          	// beinhaltet den Tabellenwert (PWM; Stern)
char    PWM_LED_TagZ4;          	// beinhaltet den Tabellenwert (PWM; Stern)
char    PWM_LED_TagZ5;          	// beinhaltet den Tabellenwert (PWM; Stern)
char    PWM_LED_TagZ6;          	// beinhaltet den Tabellenwert (PWM; Stern)
char    PWM_LED_TagZ7;          	// beinhaltet den Tabellenwert (PWM; Stern)
char    PWM_LED_TagZ8;          	// beinhaltet den Tabellenwert (PWM; Stern)
char    PWM_LED_TagZ9;          	// beinhaltet den Tabellenwert (PWM; Stern)
char    PWM_LED_TagZ10;         	// beinhaltet den Tabellenwert (PWM; Stern)
char    PWM_LED_TagZ11;         	// beinhaltet den Tabellenwert (PWM; Stern)
char    PWM_LED_TagZ12;         	// beinhaltet den Tabellenwert (PWM; Stern)


/****************** Unterprogramme und Funktionen **************************************/

/***************************************************************************************/
/* Init_Flackerlicht_Stern:                                                            */
/*                                                                                     */
/* Aufgaben:                                                                           */
/*   + Zaehlregister fuer die Flackerlichter (Tabellen) initialisieren                 */
/*   + Register fuer die Puls-Weiten-Modulation (PWM) initialisieren                   */
/*                                                                                     */
/* Uebergabeparameter:                                                                 */
/*   keiner                                                                            */
/*                                                                                     */
/* Rueckgabeparameter:                                                                 */
/*   keiner                                                                            */
/***************************************************************************************/
void Init_Flackerlicht_Stern(void)
{
    // Zaehlregister fuer die Flackerlichter (Tabellen) initialisieren
    TabZaehlerTagZ1 = KONST_TABSTART_TAGZ1;
    TabZaehlerTagZ2 = KONST_TABSTART_TAGZ2;
    TabZaehlerTagZ3 = KONST_TABSTART_TAGZ3;
    TabZaehlerTagZ4 = KONST_TABSTART_TAGZ4;
    TabZaehlerTagZ5 = KONST_TABSTART_TAGZ5;
    TabZaehlerTagZ6 = KONST_TABSTART_TAGZ6;
    TabZaehlerTagZ7 = KONST_TABSTART_TAGZ7;
    TabZaehlerTagZ8 = KONST_TABSTART_TAGZ8;
    TabZaehlerTagZ9 = KONST_TABSTART_TAGZ9;
    TabZaehlerTagZ10 = KONST_TABSTART_TAGZ10;
    TabZaehlerTagZ11 = KONST_TABSTART_TAGZ11;
    TabZaehlerTagZ12 = KONST_TABSTART_TAGZ12;
    
    // Register fuer die Puls-Weiten-Modulation (PWM) initialisieren
    PWM_Zaehler_Stern = 0;
    Gleichheitszaehler_Stern = KONST_GLEICHHEIT;
}


/***************************************************************************************/
/* Flackerlicht_Stern:                                                                 */
/*                                                                                     */
/* Aufruf:                                                                             */
/*   alle 409 us (vom Hauptprogramm)                                                   */
/*                                                                                     */
/* Aufgabe:                                                                            */
/*   PWM fuer die Flackerlichter (Stern) erzeugen, und die Leuchtdioden (Bits          */
/*   TAGZ_STERNx) setzen oder ruecksetzen.                                             */          
/*                                                                                     */
/* Vorgehensweise:                                                                     */
/*   + PWM_Zaehler_Stern = 0: Je nachdem ob der Stern "aktiv" ist                      */
/*     (TagesZaehler >= KONST_TAGZ) alle Leuchtdioden die den Stern symbolisieren      */
/*     aktivieren (setzen) und den naechsten Wert aus der Tabelle TabFlackerlicht      */
/*     lesen.                                                                          */
/*   + PWM_Zaehler_Stern = PWM_LED_TagZx: Die Leuchtdiode (Bit TAGZ_STERNx) rueck-     */
/*     setzen                                                                          */
/*   + TabZaehlerTagZx gibt an, welcher PWM-Wert aus der Tabelle (TabFlackerlicht)     */
/*     ausgegeben werden soll.                                                         */
/*                                                                                     */
/* Uebergabeparameter:                                                                 */
/*   keiner                                                                            */
/*                                                                                     */
/* Rueckgabeparameter:                                                                 */
/*   keiner                                                                            */
/*                                                                                     */
/* Anmerkung:                                                                          */
/*  + Zykluswiederholzeit des "Flackerns" bei einer Tabelle mit 256 Werten:            */
/*                                                                                     */
/*           4                                                                         */
/*    T = -------- * 256 * 8 * 32 * 5 * 256 = 16777216 us = ca. 17 Sekunden            */
/*        20 [MHz]                                                                     */
/*         |         |    |    |   |    |                                              */
/*         |         |    |    |   |    +-- Anz. der Tabellenwerte (hier 256)          */
/*         |         |    |    |   +------- Anz. der gleichen PWM (hier 5)             */
/*         |         |    |    +----------- max. PWM-Zyklen -> 61 Hz                   */
/*         |         |    +---------------- Vorteiler fuer Timer 0 (hier 8)            */
/*         |         +--------------------- Timer-0-Ueberlauf                          */
/*         +------------------------------- Takt                                       */
/***************************************************************************************/
void Flackerlicht_Stern(void)
{
    if (PWM_Zaehler_Stern == 0)
    {
        if (TagesZaehler >= KONST_TAGZ)
        {
            TAGZ_STERN1 = 1;
            TAGZ_STERN2 = 1;
            TAGZ_STERN3 = 1;
            TAGZ_STERN4 = 1;
            TAGZ_STERN5 = 1;
            TAGZ_STERN6 = 1;
            TAGZ_STERN7 = 1;
            TAGZ_STERN8 = 1;
            TAGZ_STERN9 = 1;
            TAGZ_STERN10 = 1;
            TAGZ_STERN11 = 1;
            TAGZ_STERN12 = 1;
        }
        else 
        {
            TAGZ_STERN1 = 0;
            TAGZ_STERN2 = 0;
            TAGZ_STERN3 = 0;
            TAGZ_STERN4 = 0;
            TAGZ_STERN5 = 0;
            TAGZ_STERN6 = 0;
            TAGZ_STERN7 = 0;
            TAGZ_STERN8 = 0;
            TAGZ_STERN9 = 0;
            TAGZ_STERN10 = 0;
            TAGZ_STERN11 = 0;
            TAGZ_STERN12 = 0;
        }

        Gleichheitszaehler_Stern--;
        if (Gleichheitszaehler_Stern == 0)
        {
            Gleichheitszaehler_Stern = KONST_GLEICHHEIT;

            TabZaehlerTagZ1++;
            PWM_LED_TagZ1 = TabFlackerlicht[TabZaehlerTagZ1];

            TabZaehlerTagZ2++;
            PWM_LED_TagZ2 = TabFlackerlicht[TabZaehlerTagZ2];

            TabZaehlerTagZ3++;
            PWM_LED_TagZ3 = TabFlackerlicht[TabZaehlerTagZ3];

            TabZaehlerTagZ4++;
            PWM_LED_TagZ4 = TabFlackerlicht[TabZaehlerTagZ4];

            TabZaehlerTagZ5++;
            PWM_LED_TagZ5 = TabFlackerlicht[TabZaehlerTagZ5];

            TabZaehlerTagZ6++;
            PWM_LED_TagZ6 = TabFlackerlicht[TabZaehlerTagZ6];
            
            TabZaehlerTagZ7++;
            PWM_LED_TagZ7 = TabFlackerlicht[TabZaehlerTagZ7];

            TabZaehlerTagZ8++;
            PWM_LED_TagZ8 = TabFlackerlicht[TabZaehlerTagZ8];

            TabZaehlerTagZ9++;
            PWM_LED_TagZ9 = TabFlackerlicht[TabZaehlerTagZ9];

            TabZaehlerTagZ10++;
            PWM_LED_TagZ10 = TabFlackerlicht[TabZaehlerTagZ10];

            TabZaehlerTagZ11++;
            PWM_LED_TagZ11 = TabFlackerlicht[TabZaehlerTagZ11];

            TabZaehlerTagZ12++;
            PWM_LED_TagZ12 = TabFlackerlicht[TabZaehlerTagZ12];
        }
    }
    else
    {
        if (PWM_Zaehler_Stern == PWM_LED_TagZ1) TAGZ_STERN1 = 0;
        if (PWM_Zaehler_Stern == PWM_LED_TagZ2) TAGZ_STERN2 = 0;
        if (PWM_Zaehler_Stern == PWM_LED_TagZ3) TAGZ_STERN3 = 0;
        if (PWM_Zaehler_Stern == PWM_LED_TagZ4) TAGZ_STERN4 = 0;
        if (PWM_Zaehler_Stern == PWM_LED_TagZ5) TAGZ_STERN5 = 0;
        if (PWM_Zaehler_Stern == PWM_LED_TagZ6) TAGZ_STERN6 = 0;
        if (PWM_Zaehler_Stern == PWM_LED_TagZ7) TAGZ_STERN7 = 0;
        if (PWM_Zaehler_Stern == PWM_LED_TagZ8) TAGZ_STERN8 = 0;
        if (PWM_Zaehler_Stern == PWM_LED_TagZ9) TAGZ_STERN9 = 0;
        if (PWM_Zaehler_Stern == PWM_LED_TagZ10) TAGZ_STERN10 = 0;
        if (PWM_Zaehler_Stern == PWM_LED_TagZ11) TAGZ_STERN11 = 0;
        if (PWM_Zaehler_Stern == PWM_LED_TagZ12) TAGZ_STERN12 = 0;
    }

    PWM_Zaehler_Stern++;
    if (PWM_Zaehler_Stern == KONST_PWM_OBERGRENZE) 
    {
        PWM_Zaehler_Stern = 0;
    }
}



 