/***************************************************************************************/
/* Header zum elektronischer Adventkalender in C                                       */
/*                                                                                     */
/* Compiler: CC5X                                                                      */
/*                                                                                     */
/* Entwickler: Buchgeher Stefan                                                        */
/* Entwicklungsbeginn der Software: 27. September 2008                                 */
/* Funktionsfaehig seit: 27. September 2008                                            */
/* Letzte Bearbeitung: 21. Juni 2009                                                   */
/***************************************************************************************/

#ifndef  __PROJEKT   
#define  __PROJEKT    


/****************** Pragma-Anweisungen *************************************************/
#pragma chip PIC16F87 		// PICmicro Device
//#pragma library 1		//.. library functions that are deleted if unused


/****************** Externe Strukturen  ************************************************/
/* keine externen Strukturen verwendet */


/****************** Externe Register  **************************************************/
extern bank1 unsigned char   Flackerlichter0;
extern bank1 unsigned char   Flackerlichter1;
extern bank1 unsigned char   Flackerlichter2;
extern bank1 unsigned char   Flackerlichter3;
extern bank1 unsigned char   Flackerlichter4;
extern bank1 unsigned char   Flackerlichter5;
extern bank1 unsigned char   Flackerlichter6;
extern bank1 unsigned char   Flackerlichter7;
extern bank1 unsigned char   Flackerlichter8;
extern bank1 unsigned char   Flackerlichter9;
extern bank1 unsigned char   Flackerlichter10;
extern bank1 unsigned char   Flackerlichter11;
extern bank1 unsigned char   Flackerlichter12;

extern bank1 unsigned char   TagesZaehler;


/****************** Bits in den externen Registern *************************************/
bit TAGA_BAUM1       @       Flackerlichter0.0;
bit TAGA_BAUM2       @       Flackerlichter0.1;
bit TAGA_BAUM3       @       Flackerlichter0.2;
bit TAGA_BAUM4       @       Flackerlichter0.7;
bit TAGA_BAUM5       @       Flackerlichter1.0;
bit TAGA_BAUM6       @       Flackerlichter1.1;
bit TAGA_BAUM7       @       Flackerlichter1.4;
bit TAGA_BAUM8       @       Flackerlichter1.7;
bit TAGA_BAUM9       @       Flackerlichter2.2;
bit TAGA_BAUM10      @       Flackerlichter2.6;
bit TAGA_BAUM11      @       Flackerlichter2.7;
bit TAGA_BAUM12      @       Flackerlichter3.1;
bit TAGA_BAUM13      @       Flackerlichter3.6;
bit TAGA_BAUM14      @       Flackerlichter3.7;
bit TAGA_BAUM15      @       Flackerlichter4.2;
bit TAGA_BAUM16      @       Flackerlichter5.1; 
bit TAGA_BAUM17      @       Flackerlichter5.7; 
bit TAGA_BAUM18      @       Flackerlichter6.3;
bit TAGA_BAUM19      @       Flackerlichter6.7;
bit TAGA_BAUM20      @       Flackerlichter7.0; 
bit TAGA_BAUM21      @       Flackerlichter7.1; 
bit TAGA_BAUM22      @       Flackerlichter7.3; 
bit TAGA_BAUM23      @       Flackerlichter7.7; 
bit TAGA_BAUM24      @       Flackerlichter8.3; 
bit TAGA_BAUM25      @       Flackerlichter8.7; 
bit TAGA_BAUM26      @       Flackerlichter9.2; 
bit TAGA_BAUM27      @       Flackerlichter9.5; 
bit TAGA_BAUM28      @       Flackerlichter9.7; 
bit TAGA_BAUM29      @       Flackerlichter10.0; 
bit TAGA_BAUM30      @       Flackerlichter10.2;
bit TAGA_BAUM31      @       Flackerlichter10.7;
bit TAGA_BAUM32      @       Flackerlichter11.0;
bit TAGA_BAUM33      @       Flackerlichter11.7;
bit TAGA_BAUM34      @       Flackerlichter12.1; 
bit TAGA_BAUM35      @       Flackerlichter12.2;
bit TAGA_BAUM36      @       Flackerlichter12.3; 
bit TAGA_BAUM37      @       Flackerlichter12.4; 
bit TAGA_BAUM38      @       Flackerlichter12.5; 
bit TAGA_BAUM39      @       Flackerlichter12.6; 
bit TAGA_BAUM40      @       Flackerlichter12.7; 

bit TAGB_FLAMME      @       Flackerlichter0.4; 
bit TAGB_WACHS       @       Flackerlichter0.3; 
bit TAGC_FLAMME      @       Flackerlichter0.6; 
bit TAGC_WACHS       @       Flackerlichter0.5; 
bit TAGD_FLAMME      @       Flackerlichter10.3; 
bit TAGD_WACHS       @       Flackerlichter10.4; 
bit TAGE_FLAMME      @       Flackerlichter10.5;
bit TAGE_WACHS       @       Flackerlichter12.0; 
bit TAGF_FLAMME      @       Flackerlichter11.4; 
bit TAGF_WACHS       @       Flackerlichter11.6;
bit TAGG_FLAMME      @       Flackerlichter11.3; 
bit TAGG_WACHS       @       Flackerlichter11.5; 
bit TAGH_FLAMME      @       Flackerlichter10.6;
bit TAGH_WACHS       @       Flackerlichter11.2;
bit TAGI_FLAMME      @       Flackerlichter1.3;
bit TAGI_WACHS       @       Flackerlichter1.6;
bit TAGJ_FLAMME      @       Flackerlichter1.5;
bit TAGJ_WACHS       @       Flackerlichter1.2; 
bit TAGK_FLAMME      @       Flackerlichter2.1;
bit TAGK_WACHS       @       Flackerlichter2.0;
bit TAGL_FLAMME      @       Flackerlichter9.0;
bit TAGL_WACHS       @       Flackerlichter9.1;
bit TAGM_FLAMME      @       Flackerlichter9.3;
bit TAGM_WACHS       @       Flackerlichter9.4;
bit TAGN_FLAMME      @       Flackerlichter9.6;
bit TAGN_WACHS       @       Flackerlichter10.1;
bit TAGO_FLAMME      @       Flackerlichter2.4;
bit TAGO_WACHS       @       Flackerlichter2.3;
bit TAGP_FLAMME      @       Flackerlichter3.0;
bit TAGP_WACHS       @       Flackerlichter2.5;
bit TAGQ_FLAMME      @       Flackerlichter8.1;
bit TAGQ_WACHS       @       Flackerlichter8.2;
bit TAGR_FLAMME      @       Flackerlichter8.4;
bit TAGR_WACHS       @       Flackerlichter8.5;
bit TAGS_FLAMME      @       Flackerlichter8.6;
bit TAGS_WACHS       @       Flackerlichter8.0;
bit TAGT_FLAMME      @       Flackerlichter3.2;
bit TAGT_WACHS       @       Flackerlichter3.3;
bit TAGU_FLAMME      @       Flackerlichter3.4;
bit TAGU_WACHS       @       Flackerlichter3.5;
bit TAGV_FLAMME      @       Flackerlichter7.2;
bit TAGV_WACHS       @       Flackerlichter7.4;
bit TAGW_FLAMME      @       Flackerlichter7.5;
bit TAGW_WACHS       @       Flackerlichter7.6;
bit TAGX_FLAMME      @       Flackerlichter5.2;
bit TAGX_WACHS       @       Flackerlichter5.4;
bit TAGY_FLAMME      @       Flackerlichter5.6;
bit TAGY_WACHS       @       Flackerlichter5.5;

bit TAGZ_STERN1      @       Flackerlichter4.3;
bit TAGZ_STERN2      @       Flackerlichter4.4;
bit TAGZ_STERN3      @       Flackerlichter4.5;
bit TAGZ_STERN4      @       Flackerlichter4.6;
bit TAGZ_STERN5      @       Flackerlichter4.7;
bit TAGZ_STERN6      @       Flackerlichter5.0;
bit TAGZ_STERN7      @       Flackerlichter6.0;
bit TAGZ_STERN8      @       Flackerlichter6.1;
bit TAGZ_STERN9      @       Flackerlichter6.2;
bit TAGZ_STERN10     @       Flackerlichter6.4;
bit TAGZ_STERN11     @       Flackerlichter6.5;
bit TAGZ_STERN12     @       Flackerlichter6.6;


/****************** Konstanten *********************************************************/
// Konstanten fuer die Zeitbasen (ca. 10ms, 1 Sekunde, und 1 Tag)
#define KONSTZEITBASIS10MS      24
#define KONSTZEITBASIS1SEK      102
#define KONSTZEITBASIS1MIN      60
#define KONSTZEITBASIS1STD      60
#define KONSTZEITBASIS1TAG      24

#define KONST_PWM_OBERGRENZE    32
#define KONST_GLEICHHEIT        5

/* Startwert in der Tabelle fuer die einzelnen LEDs */
#define KONST_TABSTART_TAGA1    0
#define KONST_TABSTART_TAGA2    10
#define KONST_TABSTART_TAGA3    20
#define KONST_TABSTART_TAGA4    30
#define KONST_TABSTART_TAGA5    40
#define KONST_TABSTART_TAGA6    50
#define KONST_TABSTART_TAGA7    60
#define KONST_TABSTART_TAGA8    70
#define KONST_TABSTART_TAGA9    80
#define KONST_TABSTART_TAGA10   90
#define KONST_TABSTART_TAGA11   100
#define KONST_TABSTART_TAGA12   110
#define KONST_TABSTART_TAGA13   120
#define KONST_TABSTART_TAGA14   130
#define KONST_TABSTART_TAGA15   140
#define KONST_TABSTART_TAGA16   150
#define KONST_TABSTART_TAGA17   160
#define KONST_TABSTART_TAGA18   170
#define KONST_TABSTART_TAGA19   180
#define KONST_TABSTART_TAGA20   190
#define KONST_TABSTART_TAGA21   200
#define KONST_TABSTART_TAGA22   210
#define KONST_TABSTART_TAGA23   220
#define KONST_TABSTART_TAGA24   230
#define KONST_TABSTART_TAGA25   240
#define KONST_TABSTART_TAGA26   250
#define KONST_TABSTART_TAGA27   5
#define KONST_TABSTART_TAGA28   15
#define KONST_TABSTART_TAGA29   25
#define KONST_TABSTART_TAGA30   35
#define KONST_TABSTART_TAGA31   45
#define KONST_TABSTART_TAGA32   55
#define KONST_TABSTART_TAGA33   65
#define KONST_TABSTART_TAGA34   75
#define KONST_TABSTART_TAGA35   85
#define KONST_TABSTART_TAGA36   95
#define KONST_TABSTART_TAGA37   105
#define KONST_TABSTART_TAGA38   115
#define KONST_TABSTART_TAGA39   125
#define KONST_TABSTART_TAGA40   135
#define KONST_TABSTART_TAGB     25
#define KONST_TABSTART_TAGC     75
#define KONST_TABSTART_TAGD     125
#define KONST_TABSTART_TAGE     175
#define KONST_TABSTART_TAGF     10
#define KONST_TABSTART_TAGG     60
#define KONST_TABSTART_TAGH     110
#define KONST_TABSTART_TAGI     160
#define KONST_TABSTART_TAGJ     210
#define KONST_TABSTART_TAGK     20
#define KONST_TABSTART_TAGL     70
#define KONST_TABSTART_TAGM     120
#define KONST_TABSTART_TAGN     170
#define KONST_TABSTART_TAGO     220
#define KONST_TABSTART_TAGP     30
#define KONST_TABSTART_TAGQ     80
#define KONST_TABSTART_TAGR     130
#define KONST_TABSTART_TAGS     180
#define KONST_TABSTART_TAGT     230
#define KONST_TABSTART_TAGU     40
#define KONST_TABSTART_TAGV     90
#define KONST_TABSTART_TAGW     140
#define KONST_TABSTART_TAGX     190
#define KONST_TABSTART_TAGY     240
#define KONST_TABSTART_TAGZ1    5
#define KONST_TABSTART_TAGZ2    35
#define KONST_TABSTART_TAGZ3    65
#define KONST_TABSTART_TAGZ4    95
#define KONST_TABSTART_TAGZ5    125
#define KONST_TABSTART_TAGZ6  	155
#define KONST_TABSTART_TAGZ7    185
#define KONST_TABSTART_TAGZ8    215
#define KONST_TABSTART_TAGZ9    245
#define KONST_TABSTART_TAGZ10   55
#define KONST_TABSTART_TAGZ11   105
#define KONST_TABSTART_TAGZ12 	155

/* Zuordnung Tage 1 bis 24 */
#define KONST_TAGA          1
#define KONST_TAGB          6
#define KONST_TAGC          3
#define KONST_TAGD          24
#define KONST_TAGE          10
#define KONST_TAGF          20
#define KONST_TAGG          14
#define KONST_TAGH          5
#define KONST_TAGI          7
#define KONST_TAGJ          18
#define KONST_TAGK          11 
#define KONST_TAGL          1
#define KONST_TAGM          15
#define KONST_TAGN          23 
#define KONST_TAGO          16
#define KONST_TAGP          12
#define KONST_TAGQ          22 
#define KONST_TAGR          8
#define KONST_TAGS          4
#define KONST_TAGT          19 
#define KONST_TAGU          2
#define KONST_TAGV          13
#define KONST_TAGW          21 
#define KONST_TAGX          17 
#define KONST_TAGY          9
#define KONST_TAGZ          24 


/****************** Tabelle ************************************************************/
/* Tabelle fuer Flackerlicht */
const char TabFlackerlicht[256] =
{
    17,20,22,22,25,25,27,31,30,23,19,18,19,17,15,
    15,10,8,4,4,10,20,23,25,25,25,23,21,20,24,17,
    19,25,29,31,27,22,29,29,29,31,31,27,21,16,10,5,
    5,6,7,8,10,10,15,15,15,18,16,15,19,19,21,23,
    23,22,23,21,23,21,19,17,17,15,15,14,15,15,15,17,
    17,23,23,23,23,21,21,23,23,23,17,17,16,18,18,17,
    13,17,15,21,21,25,25,28,20,20,17,16,14,10,8,5,
    8,10,7,7,5,4,8,4,8,10,11,15,18,22,22,22,
    28,28,31,31,28,25,29,31,27,22,29,29,29,31,31,27,
    21,16,10,5,5,6,7,8,10,10,10,12,15,6,6,4,0,
    0,0,5,10,10,16,25,25,28,20,20,28,28,31,31,31,
    27,20,10,9,6,6,6,6,10,10,15,15,15,10,10,5,
    5,5,10,10,20,18,20,20,25,25,19,18,20,10,6,6,
    0,1,4,10,10,15,15,20,20,20,22,23,24,28,22,16,
    14,8,0,0,10,10,20,30,31,30,28,26,30,30,28,28,
    25,25,28,28,31,31,25,25,30,30,31,31,29,29,27,22
}; 


/****************** Portbelegung *******************************************************/
/* Port A */
#pragma bit Port_DataIn         @    PORTA.2
#pragma bit Port_Enable         @    PORTA.1
#pragma bit Port_Clock          @    PORTA.4

/* Port B */
#pragma bit Jumper1             @    PORTB.1
#pragma bit Jumper2             @    PORTB.2
#pragma bit Jumper3             @    PORTB.3


/****************** Funktionsprototypen ************************************************/
extern page0 void Flackerlicht_Baum(void);
extern page0 void Init_Flackerlicht_Baum(void);
extern page1 void Flackerlicht_Kerzen(void);
extern page1 void Init_Flackerlicht_Kerzen(void); 
extern page1 void Flackerlicht_Stern(void);
extern page1 void Init_Flackerlicht_Stern(void); 
 
#endif 
